codeforce-149D——括号匹配染色+区间dp

题目链接:http://codeforces.com/problemset/problem/149/D

Once Petya read a problem about a bracket sequence. He gave it much thought but didn't find a solution. Today you will face it.

You are given string s. It represents a correct bracket sequence. A correct bracket sequence is the sequence of opening ("(") and closing (")") brackets, such that it is possible to obtain a correct mathematical expression from it, inserting numbers and operators between the brackets. For example, such sequences as "(())()" and "()" are correct bracket sequences and such sequences as ")()" and "(()" are not.

In a correct bracket sequence each bracket corresponds to the matching bracket (an opening bracket corresponds to the matching closing bracket and vice versa). For example, in a bracket sequence shown of the figure below, the third bracket corresponds to the matching sixth one and the fifth bracket corresponds to the fourth one.

You are allowed to color some brackets in the bracket sequence so as all three conditions are fulfilled:

  • Each bracket is either not colored any color, or is colored red, or is colored blue.
  • For any pair of matching brackets exactly one of them is colored. In other words, for any bracket the following is true: either it or the matching bracket that corresponds to it is colored.
  • No two neighboring colored brackets have the same color.

Find the number of different ways to color the bracket sequence. The ways should meet the above-given conditions. Two ways of coloring are considered different if they differ in the color of at least one bracket. As the result can be quite large, print it modulo 1000000007 (109 + 7).

Input

The first line contains the single string s (2 ≤ |s| ≤ 700) which represents a correct bracket sequence.

Output

Print the only number — the number of ways to color the bracket sequence that meet the above given conditions modulo 1000000007 (109 + 7).

Examples

Input

(())

Output

12

Input

(()())

Output

40

Input

()

Output

4

Note

Let's consider the first sample test. The bracket sequence from the sample can be colored, for example, as is shown on two figures below.

The two ways of coloring shown below are incorrect.

 

题目翻译:

‎一旦 Petya 读取了有关括号序列的问题。他考虑了很多,但没有找到解决办法。今天,你将面对它。‎

‎您被授予字符串‎‎s‎‎。它表示正确的括号序列。正确的括号序列是打开‎‎("‎‎) 和结束 ("‎‎)‎‎") ") 的括号的顺序,以便可以从它获得正确的数学表达式,在括号之间插入数字和运算符。例如,‎‎诸如"(())()()"‎‎和"()"这样的序列是正确的括号序列,诸如"()"和"()"这样的序列则‎‎不是。‎

‎在正确的括号序列中,每个支架对应于匹配的支架(左括号对应于匹配的右括号,反之亦然)。例如,在下图所示的括号序列中,第三个括号对应于匹配的第六个括号,第五个括号对应于第四个括号。‎

‎您可以给括号序列中的某些括号着色,以便满足所有三个条件:‎

  • ‎每个括号不是颜色任何颜色,或者是红色,或者是蓝色。‎
  • ‎对于任何匹配括号的一对,它们中只有一个是彩色的。换句话说,对于任何括号,以下都是true:它或与之对应的匹配括号是彩色的。‎
  • ‎没有两个相邻的彩色括号具有相同的颜色。‎

‎查找为括号序列着色的不同方法的数量。方法应满足上述条件。如果两种着色方式在至少一个括号的颜色上有所不同,则它们被视为不同。由于结果可能相当大,打印它 modulo ‎‎1000000007‎‎ (‎‎10‎‎9‎‎ + 7‎‎)。‎

‎输入‎

‎第一行包含单个字符串 s ‎‎ ‎‎ ‎‎ ( 2‎‎= | |‎‎s‎‎|[ 700‎‎),表示正确的括号序列。‎

‎输出‎

‎打印唯一的数字 - 为符合上述条件(modulo ‎‎1000000007‎‎ ) (‎‎10‎‎9‎‎ + 7‎‎) 的支架序列着色的方法数。‎

 

括号匹配的变形题,不过要给括号染色,并且要求相连括号颜色不相同,匹配括号一个有颜色,一个没有。

详细解析和过程请参考代码。

#include <iostream>
#include<algorithm>
#include<stack>
#include<cstring>
#include<cstdio>
#define ll long long
using namespace std;
const int mod=1e9+7;
const int maxn=705;
string s;
stack<int> q;
int match[maxn];//匹配数组,存储对应括号的下标 
ll dp[maxn][maxn][3][3];//dp[i][j][l][r]表示从i到j区间中两端的颜色分别为l,r的方案个数
//0表示没有颜色,1表示蓝,2表示红色
//状态转移方程为:
/*	if(l与r是配对的)
		递归(l+1,r-1)
		状态转移方程:
		if(j!=1)	dp[l][r][0][1]=(dp[l][r][0][1]+dp[l+1][r-1][i][j])%mod;
		if(i!=1)	dp[l][r][1][0]=(dp[l][r][1][0]+dp[l+1][r-1][i][j])%mod;
		if(j!=2)	dp[l][r][0][2]=(dp[l][r][0][2]+dp[l+1][r-1][i][j])%mod; 
		if(i!=2)	dp[l][r][2][0]=(dp[l][r][2][0]+dp[l+1][r-1][i][j])%mod;
		很容易理解,因为l+1和l以及r-1和r不能同色 
	if(l与r不配对) 
		递归(l,mid)和(mid+1,r) 
		if(k与q的数字不相同)——因为相邻不同色
		dp[l][r][i][j]=(dp[l][r][i][j]+(dp[l][mid][i][k]*dp[mid+1][r][q][j])%mod)%mod;
		其中 mid为与 l 匹配的括号的下标 ,k为mid的颜色,q为mid+1的颜色
		也很好理解,区间dp的经典做法,大区间拆成小区间,mid就是区间dp中的最优分割点 
	边界条件:如果区间长度为 1 ,那么左端点和右端点不能同色,满足
	dp[l][r][0][1]=dp[l][r][0][2]=dp[l][r][1][0]=dp[l][r][2][0]=1
*/ 
void getmatch(){//利用栈的性质得到匹配数组 
	int len=s.size();
	for(int i = 0;i<len;++i){
		if(s[i]=='(') q.push(i);
		else{
			match[i]=q.top();
			match[q.top()]=i;
			q.pop();
		}
	}
}
void dfs(int l,int r){
	if(l+1==r){
		dp[l][r][0][1]=dp[l][r][1][0]=dp[l][r][2][0]=dp[l][r][0][2]=1;
		return ;
	}
	if(match[l]==r){
		dfs(l+1,r-1);
		for(int i = 0;i<3;++i){
			for(int j = 0;j<3;++j){
				if(j!=1)	dp[l][r][0][1]=(dp[l+1][r-1][i][j]+dp[l][r][0][1])%mod;
				if(j!=2)	dp[l][r][0][2]=(dp[l+1][r-1][i][j]+dp[l][r][0][2])%mod;
				if(i!=1)	dp[l][r][1][0]=(dp[l+1][r-1][i][j]+dp[l][r][1][0])%mod;
				if(i!=2)	dp[l][r][2][0]=(dp[l+1][r-1][i][j]+dp[l][r][2][0])%mod;
			}
		} 
		return ;
	}
	else{
		int mid=match[l];
		dfs(l,mid);
		dfs(mid+1,r);
		for(int i = 0;i<3;++i)
			for(int j = 0;j<3;++j)
				for(int k = 0;k<3;++k)
					for(int m=0;m<3;++m)
						if(!(k==1&&m==1)&&!(k==2&&m==2))
							dp[l][r][i][j]=(dp[l][r][i][j]+(dp[l][mid][i][k]*dp[mid+1][r][m][j])%mod)%mod;
		return ;
	}
}
int main(int argc, char** argv) {
	cin>>s;
	getmatch();//得到匹配数组
	memset(dp,0,sizeof(dp));
	int len=s.size();
	dfs(0,len-1);
	ll ans=0;
	for(int i = 0;i<3;++i)
		for(int j = 0;j<3;++j)
			ans=(ans+dp[0][len-1][i][j])%mod;
	printf("%lld\n",ans);
	return 0;
}

 

  • 2
    点赞
  • 2
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
### 回答1: #include <stdio.h> int main(){ //定义一个3*3的数组用来存储棋盘 int board[3][3]={0}; int x,y,turn=1; while (1){ //打印棋盘 printf("当前棋盘:\n"); for (x=0;x<3;x++){ for (y=0;y<3;y++){ printf("%d ",board[x][y]); } printf("\n"); } //根据turn的值来判断谁轮到落子 if (turn==1){ printf("轮到X落子,请输入落子的位置(x y):"); }else { printf("轮到O落子,请输入落子的位置(x y):"); } scanf("%d %d",&x,&y); //将落子位置的值设置为对应的值 board[x][y] = turn; //改变轮到谁落子 turn = -turn; //判断谁赢了 if (board[0][0]==board[1][1] && board[1][1]==board[2][2] && board[2][2]!=0){ printf("游戏结束,获胜者是%c\n",board[0][0]==1?'X':'O'); break; } if (board[2][0]==board[1][1] && board[1][1]==board[0][2] && board[0][2]!=0){ printf("游戏结束,获胜者是%c\n",board[2][0]==1?'X':'O'); break; } for (x=0;x<3;x++){ if (board[x][0]==board[x][1] && board[x][1]==board[x][2] && board[x][2]!=0){ printf("游戏结束,获胜者是%c\n", board[x][0] == 1 ? 'X' : 'O'); break; } if (board[0][x]==board[1][x] && board[1][x]==board[2][x] && board[2][x]!=0){ printf("游戏结束,获胜者是%c\n", board[0][x] == 1 ? 'X' : 'O'); break; } } } return 0; } ### 回答2: 为了回答这个问题,需要提供题目的具体要求和规则。由于提供的信息不够具体,无法为您提供准确的代码。但是,我可以给您一个简单的Tic-tac-toe游戏的示例代码,供您参考: ```c #include <stdio.h> #include <stdbool.h> // 判断游戏是否结束 bool isGameOver(char board[][3]) { // 判断每行是否有3个相同的棋子 for(int i = 0; i < 3; i++) { if(board[i][0] != '.' && board[i][0] == board[i][1] && board[i][0] == board[i][2]) { return true; } } // 判断每列是否有3个相同的棋子 for(int i = 0; i < 3; i++) { if(board[0][i] != '.' && board[0][i] == board[1][i] && board[0][i] == board[2][i]) { return true; } } // 判断对角线是否有3个相同的棋子 if(board[0][0] != '.' && board[0][0] == board[1][1] && board[0][0] == board[2][2]) { return true; } if(board[0][2] != '.' && board[0][2] == board[1][1] && board[0][2] == board[2][0]) { return true; } return false; } // 输出棋盘 void printBoard(char board[][3]) { for(int i = 0; i < 3; i++) { for(int j = 0; j < 3; j++) { printf("%c ", board[i][j]); } printf("\n"); } } int main() { char board[3][3]; // 初始化棋盘 for(int i = 0; i < 3; i++) { for(int j = 0; j < 3; j++) { board[i][j] = '.'; } } int player = 1; // 玩家1先下 int row, col; while(true) { printf("Player %d's turn:\n", player); printf("Row: "); scanf("%d", &row); printf("Column: "); scanf("%d", &col); // 判断输入是否合法 if(row < 0 || row >= 3 || col < 0 || col >= 3 || board[row][col] != '.') { printf("Invalid move. Try again.\n"); continue; } // 下棋 board[row][col] = (player == 1) ? 'X' : 'O'; // 输出棋盘 printBoard(board); // 判断游戏是否结束 if(isGameOver(board)) { printf("Player %d wins!\n", player); break; } // 切换玩家 player = (player == 1) ? 2 : 1; } return 0; } ``` 这段代码实现了一个简单的命令行下的Tic-tac-toe游戏。玩家1使用'X'棋子,玩家2使用'O'棋子。玩家依次输入行和列,下棋后更新棋盘,并判断游戏是否结束。当游戏结束时,会输出获胜者并结束游戏。 ### 回答3: 题目要求实现一个井字棋游戏的判断胜负函数。给定一个3x3的井字棋棋盘,用C语言编写一个函数,判断当前是否存在某个玩家获胜或者平局。 题目要求代码中定义一个3x3的字符数组board来表示棋盘,其中 'X' 表示玩家1在该位置放置了一个棋子, 'O' 表示玩家2在该位置放置了一个棋子, '.' 表示该位置没有棋子。 下面是实现此题的C语言代码: ```c #include <stdio.h> #include <stdbool.h> // 用于使用bool类型 bool checkWin(char board[3][3]) { // 检查每一行是否有获胜的情况 for (int row = 0; row < 3; row++) { if (board[row][0] == board[row][1] && board[row][1] == board[row][2] && board[row][0] != '.') { return true; } } // 检查每一列是否有获胜的情况 for (int col = 0; col < 3; col++) { if (board[0][col] == board[1][col] && board[1][col] == board[2][col] && board[0][col] != '.') { return true; } } // 检查对角线是否有获胜的情况 if ((board[0][0] == board[1][1] && board[1][1] == board[2][2] && board[0][0] != '.') || (board[0][2] == board[1][1] && board[1][1] == board[2][0] && board[0][2] != '.')) { return true; } return false; // 没有获胜的情况 } int main() { char board[3][3]; // 存储棋盘状态 // 读取棋盘状态 for (int i = 0; i < 3; i++) { scanf("%s", board[i]); } // 调用检查胜负的函数,并输出结果 if (checkWin(board)) { printf("YES\n"); } else { printf("NO\n"); } return 0; } ``` 这个程序中定义了一个函数checkWin,用于检查是否有玩家获胜。遍历棋盘的每一行、每一列和对角线,判断是否有连续相同的字符且不为'.',如果有,则返回true;否则返回false。 在主函数main中,首先定义一个3x3的字符数组board,然后通过循环从标准输入中读取棋盘状态。接着调用checkWin函数进行胜负判断,并根据结果输出"YES"或者"NO"。最后返回0表示程序正常结束。 请注意,该代码只包含了检查胜负的功能,并没有包含其他如用户输入、判断平局等功能。如果需要完整的游戏代码,请告知具体要求。
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值